library("future")
#library("parallelly")
#library("future.apply")
#library("doFuture")
#library("future.batchtools")
library("tictoc")


test_node <- function(i,exportsth=NULL){
  str(exportsth) #Do sth. cheap w. object
  p1 <- date() #get date
  sleep_t <- sample(10,1) #random sleep time
  Sys.sleep(sleep_t) #sleep in R
  x <- Sys.info() #System info, including host name
  return(c(run=i,time_start=p1,time_end=date(),
           pid=Sys.getpid(),host=x["nodename"],
           sleep_time=sleep_t))}

small_thing <- "cookies"
big_thing <- matrix(rnorm(1e6),nrow=1000)


tic()

plan(strategy=multisession,workers=3)

set.seed(44)
#res1 <- sapply(1:4,function(i){future(test_node(i,small_thing),seed=TRUE)})
res2 <- sapply(1:4,function(i){future(test_node(i,big_thing),seed=TRUE)})


#sapply(res1,value)
sapply(res2,value)

toc()

tic()

plan(strategy=multicore,workers=3)

set.seed(44)
#res1 <- sapply(1:4,function(i){future(test_node(i,small_thing),seed=TRUE)})
res2 <- sapply(1:4,function(i){future(test_node(i,big_thing),seed=TRUE)})

#sapply(res1,value)
sapply(res2,value)

toc()
