library("future")
#library("parallelly")
library("future.apply")
library("doFuture")
#library("future.batchtools")
#library("tictoc")


simulate_sth <- function(parameters=c(5000,1,1,
1,10000)){
out1 <- 0
for (i in 1:parameters[5]){
howmany <- rpois(1,parameters[1])
random_weights <- rexp(howmany,parameters[2])
rvs <- rnorm(n = howmany,mean = parameters[3],
sd = parameters[4])
out1 <-out1 + sum(random_weights*rvs)
}
return(out1/(parameters[5]*parameters[1]))
}

#tic()

plan(strategy=multisession,workers=3)

set.seed(44)
future_replicate(10,simulate_sth())

#toc()

#tic()


#HINT: For reproducibility, switch to doRNG here - see warning message and slides set 2, slide 6
registerDoFuture()
foreach(i=1:10,.combine=c) %dopar% {simulate_sth()}


#toc()
